#include <oxstd.h>
#import <packages/Garch6/garch>
#include <oxdraw.h>
#include <oxfloat.h>
#import <packages/arfima/arfima>

with(const startPoint, const endPoint, const ForcLength);//The function that produces forecasts for x days.

main()
{
	decl i=0;
	decl length=5; //Number of days to simulate

	
	while(i*length+length<751)//Runs through the out of sample observations
	{
		with(1+i*length,3892-750+i*length,length);
		i++;
	}
}



with(const startPoint, const endPoint,const ForcLength)
{

	decl start=startPoint;
	decl end=endPoint;
	decl length=end-start+1;

	//declares the main EGARCH model
	decl egarch = new Garch();
   	egarch.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");





	//Declares the GARCH model for simulating Oil volatility
	decl volOil = new Garch();

	volOil.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");
	//volOil.Load("C:\Users\Student\Dropbox\MASTER\Data\All data to Ox_modified data.xls");

	volOil.Deterministic(-1);
	volOil.Select(Y_VAR, {"Oil ret", 0, 0});
	volOil.CSTS(1,1);
	volOil.DISTRI(0);
	volOil.ARMA_ORDERS(0,0);
	volOil.ARFIMA(0);
	volOil.GARCH_ORDERS(1,1);
	volOil.MODEL(GARCH);
	volOil.MLE(2);
	volOil.ITER(0);

	volOil.SetSelSampleByIndex(start,end);
	volOil.Initialization(<>);
	volOil.DoEstimation(<>);
	volOil.Output();


	//Extracts and stores the volatility estimates for Oil in the EGARCH dataset
	decl OilVolAppend=zeros(start,1)|volOil.GetValue("m_vSigma2");
	egarch.Append(OilVolAppend,"Oil vol 2");
	decl parOil=volOil.GetValue("m_vPar");
	decl matSigmaOil=volOil.GetValue("m_vSigma2");
	decl lastSigmaOil=matSigmaOil[rows(volOil.GetValue("m_vSigma2"))-1];
	delete volOil;


	//Declares the GARCH model for simulating S&P volatility
	decl volSP = new Garch();

	volSP.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");
	//volSP.Load("C:\Users\Student\Dropbox\MASTER\Data\All data to Ox_modified data.xls");

	volSP.Deterministic(-1);
	volSP.Select(Y_VAR, {"SP ret", 0, 0});
	volSP.CSTS(1,1);
	volSP.DISTRI(0);
	volSP.ARMA_ORDERS(0,0);
	volSP.ARFIMA(0);
	volSP.GARCH_ORDERS(1,1);
	volSP.MODEL(GARCH);
	volSP.MLE(2);
	volSP.ITER(0);

	volSP.SetSelSampleByIndex(start,end);
	volSP.Initialization(<>);
	volSP.DoEstimation(<>);
	volSP.Output();


	//Extracts and stores the volatility estimates for S&P in the EGARCH dataset
	decl SPVolAppend=zeros(start,1)|volSP.GetValue("m_vSigma2");
	egarch.Append(SPVolAppend,"SP vol 2");

	//Saves the coefficients for later simulation
	decl parSP=volSP.GetValue("m_vPar");
	decl matSigmaSP=volSP.GetValue("m_vSigma2");
	decl lastSigmaSP=matSigmaSP[rows(volSP.GetValue("m_vSigma2"))-1];

	delete volSP;



	//Generate AR(1)-model to simulate Stock diff
	decl ARStock = new Arfima();

	ARStock.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");
	ARStock.Deterministic(-1);

	ARStock.Select(Y_VAR, {"Stock diff", 0, 0});
	//ARStock.Select(X_VAR, {"Constant", 0, 0});

	ARStock.ARMA(1,0);
	ARStock.SetSelSampleByIndex(start,end);
	ARStock.SetMethod(M_MAXLIK);
	ARStock.Estimate();
	decl ARParStock=ARStock.GetPar()[1];
	//decl meanParStock=ARStock.GetPar()[2];
	decl descStock=moments(ARStock.GetResiduals(),2);

	
	

	delete ARStock;


	//Generate AR(1)-model to simulate Stock diff

	decl ARProd = new Arfima();

	ARProd.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");
	ARProd.Deterministic(-1);

	ARProd.Select(Y_VAR, {"Prod diff", 0, 0});
	//ARProd.Select(X_VAR, {"Constant", 0, 0});

	ARProd.ARMA(1,0);
	ARProd.SetSelSampleByIndex(start,end);
	ARProd.SetMethod(M_MAXLIK);
	ARProd.Estimate();
	decl ARParProd=ARProd.GetPar()[1];
	//decl meanParProd=ARProd.GetPar()[2];
	decl descProd=moments(ARProd.GetResiduals(),2);
	

	delete ARProd;




	//Declares and stores the in-sample values of all the determinants
	decl obs=rows(dummy);
	decl determinants=zeros(obs,5+5+2);
	determinants[][5]=egarch.GetVar("Oil vol 2");
	determinants[][6]=egarch.GetVar("SP vol 2");
	determinants[][7]=egarch.GetVar("Stock diff (abs)");
	determinants[][8]=egarch.GetVar("Prod diff (abs)");
	determinants[][9]=egarch.GetVar("DD diff sq");
	determinants[][10]=egarch.GetVar("Oil ret");
	determinants[][11]=egarch.GetVar("SP ret");
	decl par,errors,Sigma2,returns;
	decl check=3;


	//This while loop makes sure the model converges, if it does not, it moves the start of the dataset one day and tries again	
	while(check>2)
	{
		decl garch = new Garch();
		garch.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls");
		garch.Append(OilVolAppend,"Oil vol 2");
		garch.Append(SPVolAppend,"SP vol 2");
		println(rows(OilVolAppend));
		println(rows(SPVolAppend));
		garch.Deterministic(-1);

		garch.Select(2, {"Oil vol 2", 1, 1});
		garch.Select(2, {"SP vol 2", 1, 1});
		garch.Select(2, {"Stock diff (abs)", 1, 1});
		garch.Select(2, {"Prod diff (abs)", 1, 1});
		garch.Select(2, {"DD diff sq", 1, 1});
		/*egarch.Select(2, {"Update", 0, 0});
		egarch.Select(2, {"Mon", 0, 0});
		egarch.Select(2, {"Spring", 0, 0});
		egarch.Select(2, {"Summer", 0, 0});
		egarch.Select(2, {"Winter", 0, 0});*/
		garch.Select(Y_VAR, {"NG ret", 0, 0});
		garch.Select(X_VAR, {"Oil ret", 1, 1});
		garch.Select(X_VAR, {"SP ret", 1, 1});
	
		garch.CSTS(1,1);
		garch.DISTRI(3);
		garch.ARMA_ORDERS(1,0);
		garch.ARFIMA(0);
		garch.GARCH_ORDERS(1,1);
		garch.MODEL(EGARCH);
		garch.MLE(2);
		garch.ITER(0);
		println(start,", ",end);
		garch.SetSelSampleByIndex(start,end);
		garch.Initialization(<>);
		garch.DoEstimation(<>);
		garch.Output();
		check=garch.m_iResult;
		if(check>2)
		{
			start=start+1;
		}
		//Saves estimates of coefficients, residuals, returns and volatility
		par=garch.GetValue("m_vPar");
		errors=garch.GetValue("m_vE");
		Sigma2=log(garch.GetValue("m_vSigma2"));
		returns=garch.GetGroup(Y_VAR);


		delete garch;
	}
	

	


	//Saves each of the coefficients as its own name to make programming easier
	decl CstM=par[0];
	decl ROil=par[1];
	decl RSP=par[2];
	decl AR=par[3];
	decl CstV=par[4];
	decl VOil=par[5];
	decl VSP=par[6];
	decl Stock=par[7];
	decl Prod =par[8];
	decl DD =par[9];
	decl Alpha =par[10];
	decl Beta =par[11];
	decl Theta1=par[12];
	decl Theta2=par[13];
	decl Asymm=par[14];
	decl Tail =par[15];

	
	decl r1,r2,e1,h1,h,sd,lnh;
	decl detImpact,ldetImpact;


	decl p=1,q=1;
	decl i,j;

	//Declares the number of simulations, and creates vectors with room for simulated returns and volatility
	decl T=rows(errors)-1;
	decl simulations=11000;
	decl numOfForc = ForcLength;  
	decl sigma_sim = Sigma2|zeros(numOfForc,1);
	decl sim_returns=returns|zeros(numOfForc,1);
	decl oil_ret=determinants[][10];
	decl sp_ret=determinants[][11];
	
	//Declares the error variables, z variables needed for the simulation. As well as the matrix for storing simulated determinants
	decl v,e,eOil,eSP,eStock,eProd, eDD;
	decl zROil,zRSP,zProd,zStock,zDD,zVOil,zVSP,z0;
	decl detValue=zeros(numOfForc,7),SigmaOil=zeros(numOfForc,1);
	decl SigmaSP=zeros(numOfForc,1);

	//Saving the start values for the simulation
	decl lSigmaSP=lastSigmaSP,lSigmaOil=lastSigmaOil;
	decl lStock=determinants[end][7], lProd=determinants[end][8], lDD=determinants[end][9];
	//Saving the last two Oil and S&P returns for later use
	decl lSPret=determinants[end][10],lOilret=determinants[end][11];
	decl l2SPret=determinants[end-1][10],l2Oilret=determinants[end-1][11];

	

	//Saving the mean and st.dev for the determinants to be simulated
	decl descDD=moments(egarch.GetVar("DD diff")[start:end],2);
	decl descROil=moments(egarch.GetVar("Oil ret")[start:end],2);
	decl descRSP=moments(egarch.GetVar("SP ret")[start:end],2);


	//For saving simulated determinants to file 
	decl detToFile=zeros(numOfForc,7*(simulations+1));
	decl ROilToFile=zeros(numOfForc,simulations);
	decl RSPToFile=zeros(numOfForc,simulations);
	decl VOilToFile=zeros(numOfForc,simulations);
	decl VSPToFile=zeros(numOfForc,simulations);
	decl StockToFile=zeros(numOfForc,simulations);
	decl ProdToFile=zeros(numOfForc,simulations);
	decl DDToFile=zeros(numOfForc,simulations);

	//Declares the g(z) function for use in EGARCH
	decl g,lg;


	//Declares the matricies for storing simulates returns and volatility
	decl saveSigma,saveReturn=zeros(numOfForc,simulations),tempSigma=zeros(numOfForc,simulations),tempReturn=zeros(numOfForc,simulations);



	//Calculates the value of E(abs(z)), which is used in the g(z) function in EGARCH
	decl as = exp(Asymm);  
	decl b = 2/((1/as)+as); 
	decl t1 = 2*b*sqrt(Tail-2)*(as^2)*gammafact((1+Tail)/2); 
	decl t2 = sqrt(M_PI)*(Tail - 1)*gammafact(Tail/2); 
	decl EabsZ = t1 / t2;


	//Declares the W variable, W is omega + ln (1 + the sum of beta * determinants)
	decl W=0,lW=0;



	//Runs through i days and j simulations of those i days
	for(j=0;j<simulations;j++)
	{
		for (i=0;i<numOfForc;i++)  
		{  
			if(i!=0)//For all but the first day, the lag of W is stored
				lW=W;
			z0=egarch.rndmskewedt(1,1,Tail,exp(Asymm));
			zVOil=rann(1,1);
			zVSP=rann(1,1);
			zRSP=rann(1,1);
			zROil=rann(1,1);
			zStock=rann(1,1);
			zProd=rann(1,1);
			zDD=rann(1,1);
			

			//Simulated determinants in mean equation
			if(i==0)
			{
				detValue[i][0]=l2Oilret;
				detValue[i][1]=l2SPret;
			}
			else if(i==1)
			{
				detValue[i][0]=lOilret;
				detValue[i][1]=lSPret;
			}
			else
			{
				//Simulating Oil and S&P returns
				detValue[i][0]=parOil[0]+zROil*sqrt(detValue[i-1][2]);
				detValue[i][1]=parSP[0]+zRSP*sqrt(detValue[i-1][3]);

			}
			
			//Simulated determinants in volatility equation
			if(i==0)
			{
				detValue[i][2]=lSigmaOil;
				detValue[i][3]=lSigmaSP;
				detValue[i][4]=fabs(lStock);
				detValue[i][5]=fabs(lProd);
				detValue[i][6]=lDD^2;
				
			}
			else
			{
				//Simulating the GARCH modelled determinants
				detValue[i][2]=parOil[1]+parOil[2]*(zVOil*sqrt(lSigmaOil))^2+parOil[3]*lSigmaOil;
				detValue[i][3]=parSP[1]+parSP[2]*(zVSP*sqrt(lSigmaSP))^2+parSP[3]*lSigmaSP;

				//Saving the value for use next run
				lSigmaOil=detValue[i][2];
				lSigmaSP=detValue[i][3];
				
				//Simulated the non-absolute value of the determinant
				detValue[i][4]=ARParStock*lStock+(zStock*descStock[2]+descStock[1]);
				detValue[i][5]=ARParProd*lProd+(zProd*descProd[2]+descProd[1]);

				//Saving the non-absolute value of the determinant for use next run
				lStock=detValue[i][4];
				lProd=detValue[i][5];

				//Saving the absolute value of the determinant
				detValue[i][4]=fabs(detValue[i][4]);
				detValue[i][5]=fabs(detValue[i][5]);

				//Creating the DD determinant and saving
				detValue[i][6]=(descDD[1]+zDD*descDD[2])^2;
			}


			detImpact=0;
			W=0;
			//Calculating the impact from the simulated determinants
			for(v=0;v<5;v++)
			{
				detImpact+=detValue[i][2+v]*par[5+v];
			}

			

			//Calculates the value of the residual and uses this to create returns for day t
			e=z0*sqrt(exp(sigma_sim[T+i][0]));
			sim_returns[T+i]=CstM+ROil*detValue[i][0]+RSP*detValue[i][1]+AR*sim_returns[T+i-1]+e;

			//Stores the value of W for use in the volatility equation
			W=CstV+log(1+detImpact);
			if(i==0)//For the first day
				lW=W;

			//Calculates the value of g(z)	
			g=Theta1*z0+Theta2*(fabs(z0)-EabsZ);
			if(i==0)
				lg=g;


			//This calculates the volatility for day t+1	
			sigma_sim[T+i+1][0] = W+g+Alpha*lg+Beta*(sigma_sim[T+i]-lW);



			
			lg=g;//Stores the value of g for use for next days estimate
		}
		
		
		for(i=0;i<numOfForc;i++)//For each simulation, simulated values of all the determinants, volatility and returns are stored
		{
			tempSigma[i][j]=exp(sigma_sim[T+i][0]);
			tempReturn[i][j]=sim_returns[T+i];
	 		ROilToFile[i][j]=detValue[i][0];//Oil return
			RSPToFile[i][j]=detValue[i][1];//S&P return
			VOilToFile[i][j]=detValue[i][2];//Oil vol
			VSPToFile[i][j]=detValue[i][3];//S&P vol
			StockToFile[i][j]=detValue[i][4];//Stock
			ProdToFile[i][j]=detValue[i][5];//Prod
			DDToFile[i][j]=detValue[i][6];//DD
		
		}			
	 }
	 //Convert start and numOfForc to strings such that they can be used in the filenames stored
	 decl s=sprint(start);
	 decl F=sprint(numOfForc);


	 //Saves the matix of simulated volatility and returns in the excel files specified
	 savemat("sigma"~s~"with"~F~"forecasts.xls",tempSigma');
	 savemat("returns"~s~"with"~F~"forecasts.xls",tempReturn');
	 /*savemat("ROil"~s~"with"~F~"forecasts.xls",ROilToFile');
	 savemat("RSP"~s~"with"~F~"forecasts.xls",RSPToFile');
	 savemat("VOil"~s~"with"~F~"forecasts.xls",VOilToFile');
	 savemat("VSP"~s~"with"~F~"forecasts.xls",VSPToFile');
	 savemat("Stock"~s~"with"~F~"forecasts.xls",StockToFile');
	 savemat("Prod"~s~"with"~F~"forecasts.xls",ProdToFile');
	 savemat("DD"~s~"with"~F~"forecasts.xls",DDToFile'); */
	 println("---------------------------");
	 println("DONE with: ",start);

   	delete egarch,OilVolAppend,SPVolAppend;

}



