#include <oxstd.h>
#include <oxdraw.h>
#import <packages/garch6/garch>

run(const modelType, const distType, const AR);

main()
{
	decl i,j,k,l;
	for(l=1;l<2;l++)		 // sets the AR-process to 0 or 1
	{
		for(j=1;j<2;j++)	 //sets the different distributions
		{
			switch (j)
			{
			case 0:
				k=j;
				break;
			case 1:
				k=j;
				break;
			case 2:
				k=j+1;
				break;
			}
			for(i=0;i<6;i++)	// sets the model type
			{
				run(i,k,l);		//runs the model with the specifications declared above   	
			}
		}
	}
}

run(const modelType, const distType, const AR)
{
	decl garchstudent, type, typeString, dist, distString;
	typeString="";
	distString="";
	dist=distType;
	type=modelType;

	//Switch statement to be able to store the files with model names
	switch (type)
	{
	case 0:
		  typeString="RiskMetrics";
		  break;
	case 1:
		  typeString="GARCH";
		  break;
	case 2:
		  typeString="EGARCH";
		  break;
	case 3:
		  typeString="GJR";
		  break;
	case 4:
		  typeString="APARCH";
		  break;
	case 5:
		  typeString="IGARCH";
		  break;
	}

	//Switch statement to be able to store the files with distribution names
	switch (dist)
	{
	case 0:
		distString="Normal";
		break;
	case 1:
		distString="Student-t";
		break;
	case 3:
		distString="Skewed student-t";
		break;
	}


	
	println(" ");
	println("*************************************************************************************************************************************");
	println("********   The type of model is: ",typeString, " with ",distString," error distribution and an AR(",AR,") process   **********************");
	println("*************************************************************************************************************************************");
	println(" ");


	//Declares the garch model (ignore the name garchstudent, it is simply a name
	garchstudent = new Garch();
	//Loads the data
	garchstudent.Load("\\\\kain.stud.iot.ntnu.no\\homedir$\\torsteri\\MyDocs\\Dropbox\\MASTER\\Data\\New estimations\\All data.xls"); // C:\Users\Student\Dropbox\MASTER\Data\All data to Ox_modified data.xls");
	//Sets the variables in the mean and variance equations 
	garchstudent.Select(2, {"Oil vol whole", 1, 1});
	garchstudent.Select(2, {"SP vol whole", 1, 1});
	garchstudent.Select(2, {"Stock diff (abs)", 1, 1});
	garchstudent.Select(2, {"Prod diff (abs)", 1, 1});
	garchstudent.Select(2, {"DD diff sq", 1, 1});
	garchstudent.Select(2, {"Update", 0, 0});
	garchstudent.Select(2, {"Mon", 0, 0});
	garchstudent.Select(2, {"Spring", 0, 0});
	garchstudent.Select(2, {"Summer", 0, 0});
	garchstudent.Select(2, {"Winter", 0, 0});
	garchstudent.Select(Y_VAR, {"NG ret", 0, 0});
	garchstudent.Select(X_VAR, {"Oil ret", 1, 1});
	garchstudent.Select(X_VAR, {"SP ret", 1, 1});
	//Sets sample size for model to run through
	garchstudent.SetSelSampleByIndex(1, 3892-3*250); 		
	//garchstudent.Info();
	
//*** SPECIFICATIONS ***//
	garchstudent.CSTS(1,1); 			// cst in Mean (1 or 0), cst in Variance (1 or 0)	
	garchstudent.DISTRI(dist);				// 0 for Gauss, 1 for Student, 2 for GED, 3 for Skewed-Student
	garchstudent.ARMA_ORDERS(AR,0); 		// AR order (p), MA order (q).
	garchstudent.GARCH_ORDERS(1,1);		// p order, q order
	garchstudent.MODEL(type);				//	0:RISKMETRICS  1:GARCH		2:EGARCH	3:GJR	4:APARCH	5:IGARCH
									//  6:FIGARCH(BBM)	7:FIGARCH(Chung)	8:FIEGARCH(BBM only)
									//  9:FIAPARCH(BBM)	10: FIAPARCH(Chung)	11: HYGARCH(BBM)	
//*** OUTPUT ***//	
	garchstudent.MLE(0);				// 0 : Second Derivates, 1 : OPG, 2 : QMLE
	garchstudent.ITER(0);				
//*** PARAMETERS ***//	
	garchstudent.Initialization(<>) ;
	garchstudent.DoEstimation(<>) ;
	garchstudent.Output();

	decl quan=<0.75,0.9,0.95,0.975,0.99>; // Quantiles investigated
	decl out_of_sample_VaR=1; // 1 to compute the out-of-sample VaR, 0 otherwize
	decl numb_out_of_sample=3*250; // number of observations in the out-of-sample period
	decl reestimate_every=1; // k: to reestimate the model every k observations
	decl Y=garchstudent.GetGroup(Y_VAR);
	decl T=garchstudent.GetcT();
	println(T);
	decl m_cA,m_cV,i,j;
	decl qu_pos,qu_neg,m_vSigma2,dfunc,m_vPar,cond_mean;
	decl m_Dist=garchstudent.GetValue("m_cDist");
	//println("Infos");
	//println("Number of observations: ", T);
	//println("Investigated quantiles: ",quan);
	//println("Number of forecasts: ", numb_out_of_sample);
	//println("Out-of-sample: re-estimate every ", reestimate_every, " observations");
/* ************************************************************************************************ */
	m_Dist=garchstudent.GetValue("m_cDist");
	m_vPar=garchstudent.GetValue("m_vPar");
	decl emp_quan_out_pos=new matrix[numb_out_of_sample][columns(quan)];
	decl emp_quan_out_neg=new matrix[numb_out_of_sample][columns(quan)];
	decl k=0;


	//Computes the Kupiec LR and DQT only if the model converges
	if (garchstudent.m_iResult<3)
	{
		for (j = 0; j < numb_out_of_sample-1 ; ++j)		//Runs through the model j times rolling the sample forward 1 day each time
		{
			garchstudent.SetSelSampleByIndex(1+j,T+j);
			garchstudent.GetPara();
            garchstudent.Initialization(<>) ;  
            garchstudent.DoEstimation(<>);
			//garchstudent.Output();
	        m_vPar=garchstudent.GetValue("m_vPar");		//Stores parameter estimates
			garchstudent.DeSelect();
			garchstudent.Select(2, {"Oil vol whole", 1, 1});
			garchstudent.Select(2, {"SP vol whole", 1, 1});
			garchstudent.Select(2, {"Stock diff (abs)", 1, 1});
			garchstudent.Select(2, {"Prod diff (abs)", 1, 1});
			garchstudent.Select(2, {"DD diff sq", 1, 1});
			garchstudent.Select(2, {"Update", 0, 0});
			garchstudent.Select(2, {"Mon", 0, 0});
			garchstudent.Select(2, {"Spring", 0, 0});
			garchstudent.Select(2, {"Summer", 0, 0});
			garchstudent.Select(2, {"Winter", 0, 0});
			garchstudent.Select(Y_VAR, {"NG ret", 0, 0});
			garchstudent.Select(X_VAR, {"Oil ret", 1, 1});
			garchstudent.Select(X_VAR, {"SP ret", 1, 1});
			garchstudent.SetSelSampleByIndex(1+j+1,T+j+1);
	        garchstudent.InitData();  
	        Y=garchstudent.GetGroup(Y_VAR);  		  
	        garchstudent.Res_Var();  
			m_vSigma2=garchstudent.GetValue("m_vSigma2")[T-1];  
	        cond_mean=Y[T-1][]-garchstudent.GetValue("m_vE")[T-1][]; 	 //calculates the conditional mean: r=u+e -> u=r-e
			

			if (m_Dist==0)		//Normal distribution
			{
				qu_pos=quann(quan)';		 //function quann is for normal dist, while quant is for student t
				qu_neg=quann(1-quan)';		
			}
			if (m_Dist==1)		//Student-t distribution
			{
				m_cV=garchstudent.GetValue("m_cV");				   // m_cV=garchstudent.GetValue("m_cV"); get the df in the distribution
				qu_pos=sqrt((m_cV-2)/m_cV)*quant(quan,m_cV)';	   
				qu_neg=sqrt((m_cV-2)/m_cV)*quant(1-quan,m_cV)';
			}
			if (m_Dist==3)		//Skewed student-t distribution
			{
				m_cV=garchstudent.GetValue("m_cV");
				m_cA=garchstudent.GetValue("m_cA");
				qu_pos=qu_neg=<>;
				for (i = 0; i < columns(quan) ; ++i)    
				{
					qu_pos|=garchstudent.INVCDFTA(quan[i],m_cA,m_cV);
					qu_neg|=garchstudent.INVCDFTA(1-quan[i],m_cA,m_cV);
				}
			}

			//Stores the empirical quantiles for short and long 
			emp_quan_out_pos[j][]=(cond_mean + sqrt(m_vSigma2).*qu_pos)'; 
			emp_quan_out_neg[j][]=(cond_mean + sqrt(m_vSigma2).*qu_neg)'; 
		
		}
		
		decl filename1,filename2,a,b,arProcess;
		if(AR==0)
			arProcess="AR(0)";
		else
			arProcess="AR(1)";
		//Runs, stores and saves the DQT and the Kupiec LR test
		a=garchstudent.VaR_DynQuant(Y[T-numb_out_of_sample:T-1], emp_quan_out_pos, emp_quan_out_neg, quan, 5, 0,0);
		b=garchstudent.VaR_Test(Y[T-numb_out_of_sample:T-1], emp_quan_out_pos, emp_quan_out_neg, quan);
		filename1=typeString~" "~distString~" "~arProcess~" Dynamic quantile.xls";
		filename2=typeString~" "~distString~" "~arProcess~" Kupiec.xls";
		savemat(filename1,a);
		savemat(filename2,b);
	}
	delete garchstudent;
}